@echo off

set EXPIRATION_POINT=%1
if "%EXPIRATION_POINT%" == "" (
  set EXPIRATION_POINT=2099-12-31
)

FOR /F "tokens=*" %%i in ('sqlite3.exe asn_dml_objects.db3 "select strftime('%%s', '%EXPIRATION_POINT%')"') do @SET EXPIRATION_STAMP=%%i

echo %DATE% %TIME%: Removing history older than %EXPIRATION_POINT%

set QUERY=^
BEGIN TRANSACTION;^
DROP TABLE IF EXISTS BusinessObjectsOrig;^
DROP TABLE IF EXISTS BusinessObjectImageOrig;^
ALTER TABLE BusinessObjects RENAME TO BusinessObjectsOrig;^
ALTER TABLE BusinessObjectImage RENAME TO BusinessObjectImageOrig;^
CREATE TABLE BusinessObjects AS SELECT ^* FROM BusinessObjectsOrig WHERE Subject NOT IN^
  (SELECT DISTINCT Subject FROM BusinessObjectsOrig^
     WHERE ((Predicate=^'.Period.FinishTime^' AND Value^<%EXPIRATION_STAMP%) AND Subject IN^
          (SELECT DISTINCT Subject FROM BusinessObjectsOrig WHERE (Predicate=^'.State^' AND Value=5) AND Subject IN^
            (SELECT DISTINCT Subject FROM BusinessObjectsOrig WHERE Predicate=^'^^Is^' AND Value=^'Tol::History::Plain::Activity^')))^
        OR (Predicate=^'.AcceptanceTime^' AND Value^<%EXPIRATION_STAMP%) AND Subject IN^
          (SELECT DISTINCT Subject FROM BusinessObjectsOrig WHERE (Predicate=^'.AcceptanceStatus^' AND Value!=0) AND Subject IN^
            (SELECT DISTINCT Subject FROM BusinessObjectsOrig WHERE Predicate=^'^^Is^' AND Value=^'Alerts::Plain::Alert^')));^
SELECT COUNT(^*) FROM BusinessObjects;^
CREATE TABLE BusinessObjectImage AS SELECT ^* FROM BusinessObjectImageOrig WHERE ObjectID ^|^| ^'-0^' NOT IN^
  (SELECT DISTINCT Subject FROM BusinessObjectsOrig^
     WHERE ((Predicate=^'.Period.FinishTime^' AND Value^<%EXPIRATION_STAMP%) AND Subject IN^
          (SELECT DISTINCT Subject FROM BusinessObjectsOrig WHERE (Predicate=^'.State^' AND Value=5) AND Subject IN^
            (SELECT DISTINCT Subject FROM BusinessObjectsOrig WHERE Predicate=^'^^Is^' AND Value=^'Tol::History::Plain::Activity^')))^
        OR (Predicate=^'.AcceptanceTime^' AND Value^<%EXPIRATION_STAMP%) AND Subject IN^
          (SELECT DISTINCT Subject FROM BusinessObjectsOrig WHERE (Predicate=^'.AcceptanceStatus^' AND Value!=0) AND Subject IN^
            (SELECT DISTINCT Subject FROM BusinessObjectsOrig WHERE Predicate=^'^^Is^' AND Value=^'Alerts::Plain::Alert^')));^
SELECT COUNT(^*) FROM BusinessObjectImage;^
DROP TABLE BusinessObjectsOrig;^
DROP TABLE BusinessObjectImageOrig;^
CREATE INDEX TupleSubjectIndex ON BusinessObjects (Subject, Predicate, ValueType, Value);^
CREATE INDEX TuplePredicateIndex ON BusinessObjects (Predicate, ValueType, Value, Subject);^
CREATE INDEX ImageIndex ON BusinessObjectImage (ObjectID);^
COMMIT TRANSACTION;^
VACUUM;

sqlite3 asn_dml_objects.db3 "%QUERY%"

echo %DATE% %TIME%: History successfully cleaned up.
